/* All Prototypes moved here Dennis J. Darland 7/3/2016 Version 2.17 */

// from built_ins.h

ptr_psi_term makePsiTerm ARGS((ptr_definition x));
ptr_psi_term makePsiList ARGS((GENERIC head, ptr_psi_term (*valueFunc)(), \
                               GENERIC (*nextFunc)()));


ptr_psi_term intListValue();
GENERIC intListNext();
ptr_psi_term residListGoal();
GENERIC residListNext();
GENERIC unitListNext ARGS(());
ptr_psi_term unitListValue ARGS(());
void setUnitList ARGS((GENERIC x));


 void init_built_in_types();

 long check_real();
 long get_real_value(ptr_psi_term, REAL *, long *);
 long unify_real_result(ptr_psi_term,REAL);
 void unify_bool_result(ptr_psi_term,long);

 void new_built_in(ptr_module,char *,def_type,long(*r)());
 long declare_operator(ptr_psi_term);

 long file_exists(char *);
 void exit_life(int);
 int abort_life(int);
 long c_abort();

 ptr_psi_term stack_nil();
 ptr_psi_term stack_cons(ptr_psi_term,ptr_psi_term);
 ptr_psi_term stack_int(long);
 ptr_psi_term stack_pair(ptr_psi_term,ptr_psi_term);
 ptr_psi_term stack_string(char *);
 ptr_psi_term stack_bytes(char *,long);

 ptr_psi_term collect_symbols(long);

// from copy.h


 void init_copy();
 void clear_copy();

 ptr_psi_term exact_copy(ptr_psi_term,long);
 ptr_psi_term quote_copy(ptr_psi_term,long);
 ptr_psi_term eval_copy(ptr_psi_term,long);
 ptr_psi_term inc_heap_copy(ptr_psi_term);

 ptr_psi_term distinct_copy(ptr_psi_term);
 ptr_node distinct_tree(ptr_node);

 void mark_quote(ptr_psi_term);
 void mark_quote_tree(ptr_node);
 void mark_eval(ptr_psi_term);
 void mark_eval_tree();
 void mark_nonstrict(ptr_psi_term);
 void bk_mark_quote(ptr_psi_term);

 ptr_psi_term translate(ptr_psi_term,long **);
// from copy.c
void mark_quote_tree_c(ptr_node,long); /* A forward declaration */



// from error.h

 void stack_info(FILE *);

 void init_trace();
 void reset_step();
 void tracing();
 void new_trace(long);
 void new_step(long);
 void toggle_trace();
 void toggle_step();
 void set_trace_to_prove();

// from extern.h -- changed int to long 7/3/2017 - 2.17

void           hash_insert(ptr_hash_table, char *, ptr_keyword);
ptr_keyword    hash_lookup(ptr_hash_table, char *);
ptr_hash_table hash_create(int);
void           hash_expand(ptr_hash_table,int);
int            hash_code(ptr_hash_table, char *);
void           hash_display(ptr_hash_table);


/* Memory-manager variables. */
/* Garbage collection is done when HEAP_POINTER-STACK_POINTER<MEM_LIMIT. */

 GENERIC stack_alloc(long);
 GENERIC heap_alloc(long);

/************************* EXTERNAL FUNCTIONS *************************/

 void init_system(); /* in life.c */ /* 26.1 */

 long (* c_rule[MAX_BUILT_INS])(); /* in built_ins.c */

 ptr_psi_term stack_psi_term(long); /* in lefun.c */
 ptr_psi_term real_stack_psi_term(long,REAL); /* in lefun.c */
 ptr_psi_term heap_psi_term(long); /* in lefun.c */



// from info.h

 void title();

// from interrupt.h



 void interrupt();
 void init_interrupt();

 void handle_interrupt();

// from lefun.h
 void save_resid(ptr_resid_block,ptr_psi_term);
 void restore_resid(ptr_resid_block,ptr_psi_term *);

 long match_aim();
 long eval_aim();

 void residuate_double(ptr_psi_term,ptr_psi_term);
 void residuate(ptr_psi_term);
 void residuate2(ptr_psi_term,ptr_psi_term);
 void residuate3(ptr_psi_term,ptr_psi_term,ptr_psi_term);
 void curry();
 long residuateGoalOnVar(ptr_goal,ptr_psi_term,ptr_psi_term);

 long do_residuation(); /* For C built-ins */
 long do_residuation_user(); /* For LIFE-defined routines */
 void do_currying();

 void release_resid(ptr_psi_term);
 void release_resid_notrail(ptr_psi_term);



/* Checking out functions */
 void check_func(ptr_psi_term);
 long deref_eval(ptr_psi_term);
 long deref_rec_eval(ptr_psi_term);
 long deref_args_eval(ptr_psi_term,long);
 void deref2_eval(ptr_psi_term);
 void deref2_rec_eval(ptr_psi_term);

/*  external check out (i_ routines do not check out functions) */
 long f_check_out(ptr_psi_term);
 long i_check_out(ptr_psi_term);
 long i_eval_args(ptr_node);

// from list.h

 void List_SetLinkProc (RefListHeader,RefListGetLinksProc );
 void List_InsertAhead (RefListHeader, Ref );
 void List_Append (RefListHeader,Ref );
 void List_InsertBefore (RefListHeader,Ref,Ref );
 void List_InsertAfter (RefListHeader,Ref,Ref );
 void List_Swap (RefListHeader,Ref,Ref );
 void List_Reverse (RefListHeader);
 void List_Remove (RefListHeader,Ref );
 void List_Concat (RefListHeader,RefListHeader );
 long List_EnumFrom (RefListHeader,Ref,RefListEnumProc,Ref );
 long List_Enum (RefListHeader,RefListEnumProc,Ref );
 long List_EnumBackFrom (RefListHeader,Ref,RefListEnumProc,Ref );
 long List_EnumBack (RefListHeader,RefListEnumProc,Ref );
 long List_Card (RefListHeader );
 long List_IsUnlink (RefListLinks );
 void List_Cut (RefListHeader,Ref,RefListHeader );

// from login.h

/* High level calls */
 void assert_clause(ptr_psi_term);
 void prove_psi_term();

/* Low level calls */
 void push_goal(goals,ptr_psi_term,ptr_psi_term,GENERIC);
 void fetch_def(ptr_psi_term,long);
 void get_one_arg(ptr_node,ptr_psi_term *);
//  void get_one_arg_addr(ptr_node,ptr_psi_term **);
//  void get_two_args(ptr_node,ptr_psi_term *,ptr_psi_term *);
 void merge_unify(ptr_node *, ptr_node); 
 void fetch_def_lazy(ptr_psi_term,ptr_definition,ptr_definition,ptr_node,ptr_node,long,long);

/* Choice points and trailing */
 void push_choice_point(goals,ptr_psi_term,ptr_psi_term,GENERIC);
 ptr_stack undo_stack;
 void push_ptr_value(type_ptr,GENERIC *);
 void push_ptr_value_global(type_ptr,GENERIC *);
 void push2_ptr_value(type_ptr,GENERIC *,GENERIC);
 void push_window(long,long,long);
 void clean_undo_window(long,long);

#ifdef TS
 void push_psi_ptr_value(ptr_psi_term,GENERIC *); /* 9.6 */
#endif

/* Detrailing */
 void undo(ptr_stack);
 void undo_actions();

/* User-interface */
 void show_count();
 struct tms start_time,end_time;
// prototypes Added DJD
 void init_io();
 void init_memory();
 void exit_if_true(long);
 void init_modules();
 void main_prove();
 void start_chrono();
 void make_type_link(ptr_definition,ptr_definition); /* Forward declaration */
 long lf_strcmp(char *,char *); //DJD
 void add_rule(ptr_psi_term,ptr_psi_term,def_type); // DJD
 void exit_life(int);
 void make_sys_type_links();
 long lf_strcmp(char *,char *);  
 void make_type_link(ptr_definition,ptr_definition);
 void check_definition(ptr_definition *);
 psi_term read_life_form(char,char);
 void prettyf(char *);
 void prettyf_quote(char *);
 void get_one_arg_addr(ptr_node,ptr_psi_term **);
 void get_two_args(ptr_node,ptr_psi_term *,ptr_psi_term *);


// void get_one_arg_addr(ptr_node,ptr_psi_term *);

// void get_two_args(ptr_node,ptr_psi_term *,ptr_psi_term *);
 long c_open_module();
 void open_module_tree(ptr_node, int *);
 int make_feature_private(ptr_psi_term);
 void insert_translation(ptr_psi_term,ptr_psi_term,long);
 void push_ptr_value(type_ptr,GENERIC *);
 void push_goal(goals,ptr_psi_term,ptr_psi_term,GENERIC);
 void push_psi_ptr_value(ptr_psi_term,GENERIC *);
 void release_resid(ptr_psi_term);
 int dummy_printf(char *,char *,char *);
 void open_module_one(ptr_psi_term, int*);
 int abort_life(int);
 long sub_CodeType(ptr_int_list,ptr_int_list);
 void check_sys_definitions();
 void clear_copy();



 long bit_length(ptr_int_list);
 int isValue(ptr_psi_term);
 int isSubTypeValue(ptr_psi_term,ptr_psi_term);
 long memory_check();
 void init_global_vars();
 void reset_stacks();
 void persistent_error_check(ptr_node, long *);
 void persistent_tree(ptr_node);
 void insert_math_builtins();
 void insert_type_builtins();
 void insert_system_builtins();
 void insert_sys_builtins();
 void persistent_one(ptr_psi_term);
 long hidden_type(ptr_definition);
 long reportAndAbort(ptr_psi_term,char *);

 int global_unify_attr();   /*  RM: Feb  9 1993  */
 int global_unify();        /*  RM: Feb 11 1993  */

 void assert_attributes(ptr_psi_term);


// from memory.h

 GENERIC heap_alloc(long);
 GENERIC stack_alloc(long);

 void garbage();

 long memory_check();

 void fail_all();

 char *GetStrOption(char *, char *);
 int GetBoolOption(char *);
 int GetIntOption(char *,int);

// from modules.h

 ptr_module set_current_module(ptr_module);
 ptr_definition update_module_symbol();
 ptr_module create_module(char *);
 char *make_module_token(ptr_module,char *);
 ptr_module extract_module_from_name(char *);
 ptr_definition update_module_symbol();
 ptr_psi_term get_function_value();
 char *strip_module_name(char *);
 char *print_symbol();
 void pretty_symbol(ptr_keyword);
 void pretty_quote_symbol(ptr_keyword);
 ptr_module find_module(char *);
 ptr_definition update_feature(ptr_module,char *);
 long lf_strcmp(char *, char *); 
 long c_set_module();
 long c_open_module();
 long c_public();
 long c_private();
 long c_private_feature();
 long c_display_modules();
 long c_display_persistent(); /*  RM: Feb 12 1993  */
 long c_trace_input();
 long c_replace();
 long c_current_module();
 long c_alias(); /*  RM: Feb 22 1993  */
 int get_module(ptr_psi_term,ptr_module *); /*  RM: Mar 11 1993  */


// from parser.h

 psi_term parse(long *);

 ptr_psi_term stack_copy_psi_term(psi_term);
 ptr_psi_term heap_copy_psi_term(psi_term);

// from print.h
 void init_print();
 void pred_write(ptr_node);
 void listing_pred_write(ptr_node,long);
 long str_to_int(char *);

 long print_variables(long);
 void print_resid_message(ptr_psi_term,ptr_resid_list);
 void print_operator_kind(FILE *,operator);

 void display_psi(FILE *,ptr_psi_term);
 void display_psi_stdout(ptr_psi_term);
 void display_psi_stream(ptr_psi_term);
 void display_psi_stderr(ptr_psi_term);

 void print_code(FILE *,ptr_int_list);


// from raw.h

 void raw_setup_builtins ();

// from sys.h

 long call_primitive(long (*fun)(),int num,psi_arg argi[],GENERIC info);

// from token.h

 void psi_term_error();

 void stdin_cleareof();
 void begin_terminal_io();
 void end_terminal_io();
 char *expand_file_name(char *);
 long open_input_file(char *);
 long open_output_file(string);

 long read_char();
 long read_line();
 void read_token(ptr_psi_term);
 void read_token_b(ptr_psi_term);

 void put_back_char(long);
 void put_back_token(psi_term);

 void save_state(ptr_psi_term);
 void restore_state(ptr_psi_term);
 void new_state(ptr_psi_term *);


/* Psi-term utilities */
 char * get_attr(ptr_psi_term,char *);
 void heap_add_int_attr(ptr_psi_term,char *,long);
 void heap_mod_int_attr(ptr_psi_term,char *,long);
 void heap_add_str_attr(ptr_psi_term,char *,char *);
 void heap_mod_str_attr(ptr_psi_term,char *,char *);
 void heap_add_psi_attr(ptr_psi_term,char *,ptr_psi_term);
 void stack_add_int_attr(ptr_psi_term,char *, long);
/*  extern  void stack_mod_int_attr(); */
 void stack_add_str_attr(ptr_psi_term,char *,char *);
/*  extern  void stack_mod_str_attr(); */
 void stack_add_psi_attr(ptr_psi_term,char *,ptr_psi_term);
 FILE *get_stream(ptr_psi_term);



/* Parser/tokenizer state handling */
 void save_parse_state(ptr_parse_block);
 void restore_parse_state(ptr_parse_block);
 void init_parse_state();

// from trees.h

 char * heap_ncopy_string(char *,int);
 char * heap_copy_string(char *);
 char * stack_copy_string(char *);

 ptr_node heap_insert(long ,GENERIC,ptr_node *,GENERIC);
 ptr_node stack_insert(long,GENERIC,ptr_node *,GENERIC);
 ptr_node bk_stack_insert(long,GENERIC,ptr_node *,GENERIC);
 ptr_node bk2_stack_insert(long,GENERIC,ptr_node *,GENERIC);
 void heap_insert_copystr(char *,ptr_node *,GENERIC);
 void stack_insert_copystr(char *,ptr_node *,GENERIC);
 void delete_attr(char *, ptr_node *);

 ptr_node find(long ,char *,ptr_node);

 long intcmp(long,long);
 long featcmp(char *, char *);

 ptr_node find_data(GENERIC,ptr_node);

 ptr_definition update_symbol(ptr_module,char *);

// from types.h

 long redefine(ptr_psi_term);

 void assert_type(ptr_psi_term);
 void assert_complicated_type(ptr_psi_term);
 void print_codes();

 void assert_protected(ptr_node,long);
 void assert_delay_check(ptr_node);
 void assert_args_not_eval(ptr_node);
 void clear_already_loaded(ptr_node);
 void inherit_always_check();

 long glb(ptr_definition,ptr_definition,ptr_definition*,ptr_int_list *);
 long glb_code(long,GENERIC,long,GENERIC,long *,GENERIC *);
 long glb_value(long,long,GENERIC,GENERIC,GENERIC,GENERIC *);
 long sub_type(ptr_definition,ptr_definition);
 long overlap_type(ptr_definition,ptr_definition);
 long matches(ptr_definition,ptr_definition,long*);

 ptr_int_list decode(ptr_int_list);
 void encode_types();

 void print_def_type(def_type);

 ptr_int_list lub(ptr_psi_term,ptr_psi_term, ptr_psi_term *);
 void or_codes(ptr_int_list,ptr_int_list);
 ptr_int_list copyTypeCode(ptr_int_list);

#ifdef X11
// from xdisplaylist.h

 ListHeader * x_display_list ();
 void x_set_gc (Display *, GC,long,unsigned long,long,Font);
 void x_record_line (ListHeader *,Action,long,long,long,long,unsigned long,unsigned long,unsigned long);
 void x_record_arc (ListHeader *, Action, long,long,long,long,long,long,unsigned long, unsigned long, unsigned long);
 void x_record_rectangle (ListHeader *, Action, long,long,long,long, unsigned long, unsigned long, unsigned long);
 void x_record_string (ListHeader *, Action, long,long,char *,long,unsigned long,unsigned long);
 void x_record_polygon (ListHeader *,Action,XPoint *,long,unsigned long,unsigned long,unsigned long);
 void x_refresh_window (Display *, Window, Pixmap, GC, ListHeader *);
 void x_free_display_list (ListHeader *);

// from xpred.h

 void 	x_setup_builtins ();
 long	x_exist_event ();
 long 	x_read_stdin_or_event (long *);
 void 	x_destroy_window(Display *, Window);
 void 	x_show_window(Display *, long);
 void 	x_hide_window(Display *, long);

#endif

// from templates.h
 long get_arg (ptr_psi_term,ptr_psi_term *, char *);

// from error.h

 long warning();
 long warningx();
 void perr(char *);
 void perr_s(char *,char *);
 void perr_s2(char *, char *, char *);
 void perr_i(char *,long);

 void report_error(ptr_psi_term,char *);
 void report_warning(ptr_psi_term,char *);
 void report_error2(ptr_psi_term,char *);
 void report_warning2(ptr_psi_term,char *);

 void nonnum_warning(ptr_psi_term,ptr_psi_term,ptr_psi_term);
 long bit_and_warning(ptr_psi_term,REAL);
 long bit_or_warning(ptr_psi_term,REAL);
 long bit_not_warning(ptr_psi_term,REAL);
 long int_div_warning(ptr_psi_term,REAL);
 long mod_warning(ptr_psi_term,REAL,int);
 long shift_warning(long,ptr_psi_term,REAL);
 void Errorline(char *,...);
 void Syntaxerrorline(char *, ...);
 void warningline(char *, ...);
 void outputline(char *, ...); /* To output_stream */
 void Infoline(char *, ...);
 void Traceline(char *, ...);

// from login.h
#ifdef TS
long trail_condition(psi_term *);
#endif

// from modules.c
char legal_in_name(char);

// from sys.c
#ifdef LIFE_NDBM
void make_ndbm_type_links();
#endif
#ifdef LIFE_DBM
void insert_dbm_builtins();
#endif
#ifdef LIFE_NDBM
void insert_ndbm_builtins();
#endif

#ifdef LIFE_NDBM
void check_ndbm_definitions();
#endif

// from built_ins.

void global_error_check(ptr_node,long *,long *);
void global_tree(ptr_node);
void global_one(ptr_psi_term);

// from copy.c

ptr_psi_term copy(ptr_psi_term,long,long); /* Forward declarations */
void mark_quote_c(ptr_psi_term,long);

/* Forward declarations */
void mark_eval_new(ptr_psi_term);
void mark_quote_new(ptr_psi_term);
void mark_eval_tree_new(ptr_node);
void mark_quote_tree_new(ptr_node);

void bk_mark_quote_tree(ptr_node);

// from lefun.c
void eval_global_var(ptr_psi_term); /*  RM: Feb 10 1993  */

long do_residuation(); /* forward declaration */
/* Forward declarations */
long check_out(ptr_psi_term);
long eval_args(ptr_node);

void deref_rec_body(ptr_psi_term);
void deref_rec_args(ptr_node);
void deref_rec_args_exc(ptr_node,long);

// from login.c
#ifdef X11
void x_hide_subwindow(Display *,long);
void x_show_subwindow(Display *,long);

#endif
long unify_body();

// from memory.c
void check_attr(ptr_node *);
void check_psi_term(ptr_psi_term *);
void check_definition(ptr_definition *);
void check_resid_block(ptr_resid_block *);


// from parser.c
/*** RICHARD Nov_4 start ***/
psi_term parse_list();
/*** RICHARD Nov_4 end ***/

// from types.h
long sub_CodeType(ptr_int_list,ptr_int_list);
